org.apache.lucene.index

## Class FilterLeafReader

- java.lang.Object
- - org.apache.lucene.index.IndexReader
  - - org.apache.lucene.index.LeafReader
    - - org.apache.lucene.index.FilterLeafReader

- All Implemented Interfaces:
    Closeable, AutoCloseable
  Direct Known Subclasses:
    ExitableDirectoryReader.ExitableFilterAtomicReader

      public class FilterLeafReader
      extends LeafReader

  A `FilterLeafReader` contains another LeafReader, which it uses as its basic source of data, possibly transforming the data along the way or providing additional functionality. The class `FilterLeafReader` itself simply implements all abstract methods of `IndexReader` with versions that pass all requests to the contained index reader. Subclasses of `FilterLeafReader` may further override some of these methods and may also provide additional methods and fields.

  NOTE: If you override `getLiveDocs()`, you will likely need to override `numDocs()` as well and vice-versa.

  NOTE: If this `FilterLeafReader` does not change the content the contained reader, you could consider overriding `IndexReader.getCoreCacheKey()` so that `CachingWrapperQuery` shares the same entries for this atomic reader and the wrapped one. `IndexReader.getCombinedCoreAndDeletesKey()` could be overridden as well if the `live docs` are not changed either.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `FilterLeafReader.FilterFields` Base class for filtering `Fields` implementations.
    `static class` | `FilterLeafReader.FilterPostingsEnum` Base class for filtering `PostingsEnum` implementations.
    `static class` | `FilterLeafReader.FilterTerms` Base class for filtering `Terms` implementations.
    `static class` | `FilterLeafReader.FilterTermsEnum` Base class for filtering `TermsEnum` implementations.

    - ### Nested classes/interfaces inherited from class org.apache.lucene.index.LeafReader

      `LeafReader.CoreClosedListener`

    - ### Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader

      `IndexReader.ReaderClosedListener`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected LeafReader` | `in` The underlying LeafReader.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FilterLeafReader(LeafReader in)` Construct a FilterLeafReader based on the specified base reader.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addCoreClosedListener(LeafReader.CoreClosedListener listener)` Expert: adds a CoreClosedListener to this reader's shared core
    `void` | `checkIntegrity()` Checks consistency of this reader.
    `protected void` | `doClose()` Implements close.
    `void` | `document(int docID, StoredFieldVisitor visitor)` Expert: visits the fields of a stored document, for custom processing/loading of each field.
    `Fields` | `fields()` Returns `Fields` for this reader.
    `BinaryDocValues` | `getBinaryDocValues(String field)` Returns `BinaryDocValues` for this field, or null if no `BinaryDocValues` were indexed for this field.
    `LeafReader` | `getDelegate()` Returns the wrapped `LeafReader`.
    `Bits` | `getDocsWithField(String field)` Returns a `Bits` at the size of `reader.maxDoc()`, with turned on bits for each docid that does have a value for this field, or null if no DocValues were indexed for this field.
    `FieldInfos` | `getFieldInfos()` Get the `FieldInfos` describing all fields in this reader.
    `Bits` | `getLiveDocs()` Returns the `Bits` representing live (not deleted) docs.
    `NumericDocValues` | `getNormValues(String field)` Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed.
    `NumericDocValues` | `getNumericDocValues(String field)` Returns `NumericDocValues` for this field, or null if no `NumericDocValues` were indexed for this field.
    `SortedDocValues` | `getSortedDocValues(String field)` Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field.
    `SortedNumericDocValues` | `getSortedNumericDocValues(String field)` Returns `SortedNumericDocValues` for this field, or null if no `SortedNumericDocValues` were indexed for this field.
    `SortedSetDocValues` | `getSortedSetDocValues(String field)` Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field.
    `Fields` | `getTermVectors(int docID)` Retrieve term vectors for this document, or null if term vectors were not indexed.
    `int` | `maxDoc()` Returns one greater than the largest possible document number.
    `int` | `numDocs()` Returns the number of documents in this index.
    `void` | `removeCoreClosedListener(LeafReader.CoreClosedListener listener)` Expert: removes a CoreClosedListener from this reader's shared core
    `String` | `toString()`
    `static LeafReader` | `unwrap(LeafReader reader)` Get the wrapped instance by `reader` as long as this reader is an instance of `FilterLeafReader`.

    - ### Methods inherited from class org.apache.lucene.index.LeafReader

      `addCoreClosedListenerAsReaderClosedListener, docFreq, getContext, getDocCount, getSumDocFreq, getSumTotalTermFreq, postings, postings, removeCoreClosedListenerAsReaderClosedListener, termDocsEnum, termPositionsEnum, terms, totalTermFreq`

    - ### Methods inherited from class org.apache.lucene.index.IndexReader

      `addReaderClosedListener, close, decRef, document, document, ensureOpen, equals, getCombinedCoreAndDeletesKey, getCoreCacheKey, getRefCount, getTermVector, hasDeletions, hashCode, incRef, leaves, numDeletedDocs, registerParentReader, removeReaderClosedListener, tryIncRef`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### in

          protected final LeafReader in

      The underlying LeafReader.

  - ### Constructor Detail

    - #### FilterLeafReader

          public FilterLeafReader(LeafReader in)

      Construct a FilterLeafReader based on the specified base reader.

      Note that base reader is closed if this FilterLeafReader is closed.

      Parameters:
        `in` - specified base reader.

  - ### Method Detail

    - #### unwrap

          public static LeafReader unwrap(LeafReader reader)

      Get the wrapped instance by `reader` as long as this reader is an instance of `FilterLeafReader`.

    - #### addCoreClosedListener

          public void addCoreClosedListener(LeafReader.CoreClosedListener listener)

      Description copied from class: `LeafReader`
      Expert: adds a CoreClosedListener to this reader's shared core
      Specified by:
        `addCoreClosedListener` in class `LeafReader`

    - #### removeCoreClosedListener

          public void removeCoreClosedListener(LeafReader.CoreClosedListener listener)

      Description copied from class: `LeafReader`
      Expert: removes a CoreClosedListener from this reader's shared core
      Specified by:
        `removeCoreClosedListener` in class `LeafReader`

    - #### getLiveDocs

          public Bits getLiveDocs()

      Description copied from class: `LeafReader`
      Returns the `Bits` representing live (not deleted) docs. A set bit indicates the doc ID has not been deleted. If this method returns null it means there are no deleted documents (all documents are live). The returned instance has been safely published for use by multiple threads without additional synchronization.
      Specified by:
        `getLiveDocs` in class `LeafReader`

    - #### getFieldInfos

          public FieldInfos getFieldInfos()

      Description copied from class: `LeafReader`
      Get the `FieldInfos` describing all fields in this reader.
      Specified by:
        `getFieldInfos` in class `LeafReader`

    - #### getTermVectors

          public Fields getTermVectors(int docID)
                                throws IOException

      Description copied from class: `IndexReader`
      Retrieve term vectors for this document, or null if term vectors were not indexed. The returned Fields instance acts like a single-document inverted index (the docID will be 0).
      Specified by:
        `getTermVectors` in class `IndexReader`
      Throws:
        `IOException`

    - #### numDocs

          public int numDocs()

      Description copied from class: `IndexReader`
      Returns the number of documents in this index.
      Specified by:
        `numDocs` in class `IndexReader`

    - #### maxDoc

          public int maxDoc()

      Description copied from class: `IndexReader`
      Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.
      Specified by:
        `maxDoc` in class `IndexReader`

    - #### document

          public void document(int docID,
                      StoredFieldVisitor visitor)
                        throws IOException

      Description copied from class: `IndexReader`
      Expert: visits the fields of a stored document, for custom processing/loading of each field. If you simply want to load all fields, use `IndexReader.document(int)`. If you want to load a subset, use `DocumentStoredFieldVisitor`.
      Specified by:
        `document` in class `IndexReader`
      Throws:
        `IOException`

    - #### doClose

          protected void doClose()
                          throws IOException

      Description copied from class: `IndexReader`
      Implements close.
      Specified by:
        `doClose` in class `IndexReader`
      Throws:
        `IOException`

    - #### fields

          public Fields fields()
                        throws IOException

      Description copied from class: `LeafReader`
      Returns `Fields` for this reader. This method will not return null.
      Specified by:
        `fields` in class `LeafReader`
      Throws:
        `IOException`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getNumericDocValues

          public NumericDocValues getNumericDocValues(String field)
                                               throws IOException

      Description copied from class: `LeafReader`
      Returns `NumericDocValues` for this field, or null if no `NumericDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getNumericDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getBinaryDocValues

          public BinaryDocValues getBinaryDocValues(String field)
                                             throws IOException

      Description copied from class: `LeafReader`
      Returns `BinaryDocValues` for this field, or null if no `BinaryDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getBinaryDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getSortedDocValues

          public SortedDocValues getSortedDocValues(String field)
                                             throws IOException

      Description copied from class: `LeafReader`
      Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getSortedNumericDocValues

          public SortedNumericDocValues getSortedNumericDocValues(String field)
                                                           throws IOException

      Description copied from class: `LeafReader`
      Returns `SortedNumericDocValues` for this field, or null if no `SortedNumericDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedNumericDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getSortedSetDocValues

          public SortedSetDocValues getSortedSetDocValues(String field)
                                                   throws IOException

      Description copied from class: `LeafReader`
      Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedSetDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getNormValues

          public NumericDocValues getNormValues(String field)
                                         throws IOException

      Description copied from class: `LeafReader`
      Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed. The returned instance should only be used by a single thread.
      Specified by:
        `getNormValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getDocsWithField

          public Bits getDocsWithField(String field)
                                throws IOException

      Description copied from class: `LeafReader`
      Returns a `Bits` at the size of `reader.maxDoc()`, with turned on bits for each docid that does have a value for this field, or null if no DocValues were indexed for this field. The returned instance should only be used by a single thread
      Specified by:
        `getDocsWithField` in class `LeafReader`
      Throws:
        `IOException`

    - #### checkIntegrity

          public void checkIntegrity()
                              throws IOException

      Description copied from class: `LeafReader`
      Checks consistency of this reader.

      Note that this may be costly in terms of I/O, e.g. may involve computing a checksum value against large data files.

      Specified by:
        `checkIntegrity` in class `LeafReader`
      Throws:
        `IOException`

    - #### getDelegate

          public LeafReader getDelegate()

      Returns the wrapped `LeafReader`.

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.